/*
 *      This file is part of GPaste.
 *
 *      Copyright 2012 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __G_PASTE_KEYBINDING_PRIVATE_H__
#define __G_PASTE_KEYBINDING_PRIVATE_H__

#include "gpaste-keybinding.h"

G_BEGIN_DECLS

typedef struct _GPasteKeybindingPrivate GPasteKeybindingPrivate;

struct _GPasteKeybinding
{
    GObject parent_instance;

    /*< private >*/
    GPasteKeybindingPrivate *priv;
};

struct _GPasteKeybindingClass
{
    GObjectClass parent_class;
};

GPasteXcbWrapper *g_paste_keybinding_get_xcb_wrapper (GPasteKeybinding *self);

GPasteKeybinding *_g_paste_keybinding_new (GType                  type,
                                           GPasteXcbWrapper      *xcb_wrapper,
                                           GPasteSettings        *settings,
                                           const gchar           *dconf_key,
                                           GPasteKeybindingGetter getter,
                                           GPasteKeybindingFunc   callback,
                                           gpointer               user_data);

G_END_DECLS

#endif /*__G_PASTE_KEYBINDING_PRIVATE_H__*/
