/* gpaste-settings-panel.c generated by valac 0.17.7, the Vala compiler
 * generated from gpaste-settings-panel.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2012 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


#define G_PASTE_TYPE_PANEL (g_paste_panel_get_type ())
#define G_PASTE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_PANEL, GPastePanel))
#define G_PASTE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_PASTE_TYPE_PANEL, GPastePanelClass))
#define G_PASTE_IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_PANEL))
#define G_PASTE_IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_PASTE_TYPE_PANEL))
#define G_PASTE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_PASTE_TYPE_PANEL, GPastePanelClass))

typedef struct _GPastePanel GPastePanel;
typedef struct _GPastePanelClass GPastePanelClass;
typedef struct _GPastePanelPrivate GPastePanelPrivate;
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;

typedef void (*GPasteBooleanCallback) (gboolean data, void* user_data);
typedef void (*GPasteMultiActionCallback) (const gchar* action, const gchar* target, void* user_data);
typedef void (*GPasteRangeCallback) (gdouble data, void* user_data);
typedef void (*GPasteTextCallback) (const gchar* data, void* user_data);
struct _GPastePanel {
	GtkGrid parent_instance;
	GPastePanelPrivate * priv;
};

struct _GPastePanelClass {
	GtkGridClass parent_class;
};

struct _GPastePanelPrivate {
	gint current_line;
};

struct _Block1Data {
	int _ref_count_;
	GPastePanel * self;
	GtkCheckButton* button;
	GPasteBooleanCallback on_value_changed;
	gpointer on_value_changed_target;
};

struct _Block2Data {
	int _ref_count_;
	GPastePanel * self;
	GtkSpinButton* button;
	GPasteRangeCallback on_value_changed;
	gpointer on_value_changed_target;
};

struct _Block3Data {
	int _ref_count_;
	GPastePanel * self;
	GtkEntry* entry;
	GPasteTextCallback on_value_changed;
	gpointer on_value_changed_target;
};

struct _Block4Data {
	int _ref_count_;
	GPastePanel * self;
	GtkEntry* entry;
	GPasteTextCallback confirm_action;
	gpointer confirm_action_target;
};

struct _Block5Data {
	int _ref_count_;
	GPastePanel * self;
	GtkComboBoxText* actions;
	GtkComboBoxText* targets;
	GPasteMultiActionCallback confirm_action;
	gpointer confirm_action_target;
};


static gpointer g_paste_panel_parent_class = NULL;

GType g_paste_panel_get_type (void) G_GNUC_CONST;
#define G_PASTE_PANEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), G_PASTE_TYPE_PANEL, GPastePanelPrivate))
enum  {
	G_PASTE_PANEL_DUMMY_PROPERTY
};
GPastePanel* g_paste_panel_new (void);
GPastePanel* g_paste_panel_construct (GType object_type);
GtkCheckButton* g_paste_panel_add_boolean_setting (GPastePanel* self, const gchar* label, gboolean value, GPasteBooleanCallback on_value_changed, void* on_value_changed_target);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda3_ (Block1Data* _data1_);
static void ___lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
void g_paste_panel_add_separator (GPastePanel* self);
static GtkLabel* g_paste_panel_add_label (GPastePanel* self, const gchar* label);
GtkSpinButton* g_paste_panel_add_range_setting (GPastePanel* self, const gchar* label, gdouble value, gdouble min, gdouble max, gdouble step, GPasteRangeCallback on_value_changed, void* on_value_changed_target);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda4_ (Block2Data* _data2_);
static void ___lambda4__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
GtkEntry* g_paste_panel_add_text_setting (GPastePanel* self, const gchar* label, const gchar* value, GPasteTextCallback on_value_changed, void* on_value_changed_target);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda5_ (Block3Data* _data3_);
static void ___lambda5__gtk_editable_changed (GtkEditable* _sender, gpointer self);
static GtkButton* g_paste_panel_add_confirm_button (GPastePanel* self, const gchar* label, GtkWidget* attach_to);
GtkEntry* g_paste_panel_add_text_confirm_setting (GPastePanel* self, const gchar* label, const gchar* value, GPasteTextCallback on_value_changed, void* on_value_changed_target, const gchar* confirm_label, GPasteTextCallback confirm_action, void* confirm_action_target);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda6_ (Block4Data* _data4_);
static gboolean ___lambda6__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static GtkComboBoxText* g_paste_panel_make_combo_box_text (GPastePanel* self, gchar** labels, int labels_length1, int labels_length2);
GtkComboBoxText* g_paste_panel_add_multi_action_setting (GPastePanel* self, gchar** action_labels, int action_labels_length1, int action_labels_length2, gchar** target_labels, int target_labels_length1, const gchar* confirm_label, GPasteMultiActionCallback confirm_action, void* confirm_action_target);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block5Data* _data5_);
static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void g_paste_panel_finalize (GObject* obj);


GPastePanel* g_paste_panel_construct (GType object_type) {
	GPastePanel * self = NULL;
	self = (GPastePanel*) g_object_new (object_type, NULL);
	self->priv->current_line = 0;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), "margin", 10, NULL);
	gtk_grid_set_column_spacing (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), (guint) 10);
	gtk_grid_set_row_spacing (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), (guint) 10);
	return self;
}


GPastePanel* g_paste_panel_new (void) {
	return g_paste_panel_construct (G_PASTE_TYPE_PANEL);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		GPastePanel * self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->button);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static void __lambda3_ (Block1Data* _data1_) {
	GPastePanel * self;
	GPasteBooleanCallback _tmp0_;
	void* _tmp0__target;
	gboolean _tmp1_ = FALSE;
	self = _data1_->self;
	_tmp0_ = _data1_->on_value_changed;
	_tmp0__target = _data1_->on_value_changed_target;
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_data1_->button, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton));
	_tmp0_ (_tmp1_, _tmp0__target);
}


static void ___lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda3_ (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GtkCheckButton* g_paste_panel_add_boolean_setting (GPastePanel* self, const gchar* label, gboolean value, GPasteBooleanCallback on_value_changed, void* on_value_changed_target) {
	GtkCheckButton* result = NULL;
	Block1Data* _data1_;
	GPasteBooleanCallback _tmp0_;
	void* _tmp0__target;
	const gchar* _tmp1_;
	GtkCheckButton* _tmp2_;
	gboolean _tmp3_;
	gint _tmp4_;
	GtkCheckButton* _tmp5_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	g_return_val_if_fail (label != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = on_value_changed;
	_tmp0__target = on_value_changed_target;
	_data1_->on_value_changed = _tmp0_;
	_data1_->on_value_changed_target = _tmp0__target;
	_tmp1_ = label;
	_tmp2_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp1_);
	g_object_ref_sink (_tmp2_);
	_data1_->button = _tmp2_;
	_tmp3_ = value;
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_data1_->button, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton), _tmp3_);
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_data1_->button, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton), "toggled", (GCallback) ___lambda3__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp4_ = self->priv->current_line;
	self->priv->current_line = _tmp4_ + 1;
	gtk_grid_attach (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (_data1_->button, GTK_TYPE_WIDGET, GtkWidget), 0, _tmp4_, 2, 1);
	_tmp5_ = _g_object_ref0 (_data1_->button);
	result = _tmp5_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}


void g_paste_panel_add_separator (GPastePanel* self) {
	GtkSeparator* _tmp0_;
	GtkSeparator* _tmp1_;
	gint _tmp2_;
	g_return_if_fail (G_PASTE_IS_PANEL (self));
	_tmp0_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->current_line;
	self->priv->current_line = _tmp2_ + 1;
	gtk_grid_attach (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GTK_TYPE_WIDGET, GtkWidget), 0, _tmp2_, 2, 1);
	_g_object_unref0 (_tmp1_);
}


static GtkLabel* g_paste_panel_add_label (GPastePanel* self, const gchar* label) {
	GtkLabel* result = NULL;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* button_label;
	gint _tmp2_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	g_return_val_if_fail (label != NULL, NULL);
	_tmp0_ = label;
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
	g_object_ref_sink (_tmp1_);
	button_label = _tmp1_;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (button_label, GTK_TYPE_MISC, GtkMisc), "xalign", (gfloat) 0, NULL);
	_tmp2_ = self->priv->current_line;
	self->priv->current_line = _tmp2_ + 1;
	gtk_grid_attach (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (button_label, GTK_TYPE_WIDGET, GtkWidget), 0, _tmp2_, 1, 1);
	result = button_label;
	return result;
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		GPastePanel * self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->button);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static void __lambda4_ (Block2Data* _data2_) {
	GPastePanel * self;
	GPasteRangeCallback _tmp0_;
	void* _tmp0__target;
	gdouble _tmp1_ = 0.0;
	self = _data2_->self;
	_tmp0_ = _data2_->on_value_changed;
	_tmp0__target = _data2_->on_value_changed_target;
	_tmp1_ = gtk_spin_button_get_value (_data2_->button);
	_tmp0_ (_tmp1_, _tmp0__target);
}


static void ___lambda4__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
	__lambda4_ (self);
}


GtkSpinButton* g_paste_panel_add_range_setting (GPastePanel* self, const gchar* label, gdouble value, gdouble min, gdouble max, gdouble step, GPasteRangeCallback on_value_changed, void* on_value_changed_target) {
	GtkSpinButton* result = NULL;
	Block2Data* _data2_;
	GPasteRangeCallback _tmp0_;
	void* _tmp0__target;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkLabel* button_label;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	GtkSpinButton* _tmp6_;
	gdouble _tmp7_;
	GtkSpinButton* _tmp8_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	g_return_val_if_fail (label != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = on_value_changed;
	_tmp0__target = on_value_changed_target;
	_data2_->on_value_changed = _tmp0_;
	_data2_->on_value_changed_target = _tmp0__target;
	_tmp1_ = label;
	_tmp2_ = g_paste_panel_add_label (self, _tmp1_);
	button_label = _tmp2_;
	_tmp3_ = min;
	_tmp4_ = max;
	_tmp5_ = step;
	_tmp6_ = (GtkSpinButton*) gtk_spin_button_new_with_range (_tmp3_, _tmp4_, _tmp5_);
	g_object_ref_sink (_tmp6_);
	_data2_->button = _tmp6_;
	_tmp7_ = value;
	gtk_spin_button_set_value (_data2_->button, _tmp7_);
	g_signal_connect_data (_data2_->button, "value-changed", (GCallback) ___lambda4__gtk_spin_button_value_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	gtk_grid_attach_next_to (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (_data2_->button, GTK_TYPE_WIDGET, GtkWidget), G_TYPE_CHECK_INSTANCE_CAST (button_label, GTK_TYPE_WIDGET, GtkWidget), GTK_POS_RIGHT, 1, 1);
	_tmp8_ = _g_object_ref0 (_data2_->button);
	result = _tmp8_;
	_g_object_unref0 (button_label);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		GPastePanel * self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->entry);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}


static void __lambda5_ (Block3Data* _data3_) {
	GPastePanel * self;
	GPasteTextCallback _tmp0_;
	void* _tmp0__target;
	const gchar* _tmp1_ = NULL;
	self = _data3_->self;
	_tmp0_ = _data3_->on_value_changed;
	_tmp0__target = _data3_->on_value_changed_target;
	_tmp1_ = gtk_entry_get_text (_data3_->entry);
	_tmp0_ (_tmp1_, _tmp0__target);
}


static void ___lambda5__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	__lambda5_ (self);
}


GtkEntry* g_paste_panel_add_text_setting (GPastePanel* self, const gchar* label, const gchar* value, GPasteTextCallback on_value_changed, void* on_value_changed_target) {
	GtkEntry* result = NULL;
	Block3Data* _data3_;
	GPasteTextCallback _tmp0_;
	void* _tmp0__target;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkLabel* entry_label;
	GtkEntry* _tmp3_;
	const gchar* _tmp4_;
	GtkEntry* _tmp5_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = on_value_changed;
	_tmp0__target = on_value_changed_target;
	_data3_->on_value_changed = _tmp0_;
	_data3_->on_value_changed_target = _tmp0__target;
	_tmp1_ = label;
	_tmp2_ = g_paste_panel_add_label (self, _tmp1_);
	entry_label = _tmp2_;
	_tmp3_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp3_);
	_data3_->entry = _tmp3_;
	_tmp4_ = value;
	gtk_entry_set_text (_data3_->entry, _tmp4_);
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_data3_->entry, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) ___lambda5__gtk_editable_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	gtk_grid_attach_next_to (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (_data3_->entry, GTK_TYPE_WIDGET, GtkWidget), G_TYPE_CHECK_INSTANCE_CAST (entry_label, GTK_TYPE_WIDGET, GtkWidget), GTK_POS_RIGHT, 1, 1);
	_tmp5_ = _g_object_ref0 (_data3_->entry);
	result = _tmp5_;
	_g_object_unref0 (entry_label);
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return result;
}


static GtkButton* g_paste_panel_add_confirm_button (GPastePanel* self, const gchar* label, GtkWidget* attach_to) {
	GtkButton* result = NULL;
	const gchar* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* button;
	GtkWidget* _tmp2_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (GTK_IS_WIDGET (attach_to), NULL);
	_tmp0_ = label;
	_tmp1_ = (GtkButton*) gtk_button_new_with_label (_tmp0_);
	g_object_ref_sink (_tmp1_);
	button = _tmp1_;
	_tmp2_ = attach_to;
	gtk_grid_attach_next_to (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (button, GTK_TYPE_WIDGET, GtkWidget), _tmp2_, GTK_POS_RIGHT, 1, 1);
	result = button;
	return result;
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (void * _userdata_) {
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		GPastePanel * self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->entry);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}


static gboolean __lambda6_ (Block4Data* _data4_) {
	GPastePanel * self;
	gboolean result = FALSE;
	GPasteTextCallback _tmp0_;
	void* _tmp0__target;
	const gchar* _tmp1_ = NULL;
	self = _data4_->self;
	_tmp0_ = _data4_->confirm_action;
	_tmp0__target = _data4_->confirm_action_target;
	_tmp1_ = gtk_entry_get_text (_data4_->entry);
	_tmp0_ (_tmp1_, _tmp0__target);
	result = FALSE;
	return result;
}


static gboolean ___lambda6__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda6_ (self);
	return result;
}


GtkEntry* g_paste_panel_add_text_confirm_setting (GPastePanel* self, const gchar* label, const gchar* value, GPasteTextCallback on_value_changed, void* on_value_changed_target, const gchar* confirm_label, GPasteTextCallback confirm_action, void* confirm_action_target) {
	GtkEntry* result = NULL;
	Block4Data* _data4_;
	GPasteTextCallback _tmp0_;
	void* _tmp0__target;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GPasteTextCallback _tmp3_;
	void* _tmp3__target;
	GtkEntry* _tmp4_ = NULL;
	const gchar* _tmp5_;
	GtkButton* _tmp6_ = NULL;
	GtkButton* button;
	GtkEntry* _tmp7_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	g_return_val_if_fail (confirm_label != NULL, NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = confirm_action;
	_tmp0__target = confirm_action_target;
	_data4_->confirm_action = _tmp0_;
	_data4_->confirm_action_target = _tmp0__target;
	_tmp1_ = label;
	_tmp2_ = value;
	_tmp3_ = on_value_changed;
	_tmp3__target = on_value_changed_target;
	_tmp4_ = g_paste_panel_add_text_setting (self, _tmp1_, _tmp2_, _tmp3_, _tmp3__target);
	_data4_->entry = _tmp4_;
	_tmp5_ = confirm_label;
	_tmp6_ = g_paste_panel_add_confirm_button (self, _tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_data4_->entry, GTK_TYPE_WIDGET, GtkWidget));
	button = _tmp6_;
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (button, GTK_TYPE_WIDGET, GtkWidget), "button-press-event", (GCallback) ___lambda6__gtk_widget_button_press_event, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp7_ = _g_object_ref0 (_data4_->entry);
	result = _tmp7_;
	_g_object_unref0 (button);
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return result;
}


static GtkComboBoxText* g_paste_panel_make_combo_box_text (GPastePanel* self, gchar** labels, int labels_length1, int labels_length2) {
	GtkComboBoxText* result = NULL;
	GtkComboBoxText* _tmp0_;
	GtkComboBoxText* combo_box;
	GtkComboBoxText* _tmp14_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp0_);
	combo_box = _tmp0_;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_;
				gint _tmp4_;
				gchar** _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				gint _tmp6_;
				GtkComboBoxText* _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				gint _tmp8__length2;
				gint _tmp9_;
				const gchar* _tmp10_;
				gchar** _tmp11_;
				gint _tmp11__length1;
				gint _tmp11__length2;
				gint _tmp12_;
				const gchar* _tmp13_;
				_tmp2_ = _tmp1_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp4_ = i;
				_tmp5_ = labels;
				_tmp5__length1 = labels_length1;
				_tmp5__length2 = labels_length2;
				_tmp6_ = _tmp5__length1;
				if (!(_tmp4_ < _tmp6_)) {
					break;
				}
				_tmp7_ = combo_box;
				_tmp8_ = labels;
				_tmp8__length1 = labels_length1;
				_tmp8__length2 = labels_length2;
				_tmp9_ = i;
				_tmp10_ = _tmp8_[(_tmp9_ * _tmp8__length2) + 0];
				_tmp11_ = labels;
				_tmp11__length1 = labels_length1;
				_tmp11__length2 = labels_length2;
				_tmp12_ = i;
				_tmp13_ = _tmp11_[(_tmp12_ * _tmp11__length2) + 1];
				gtk_combo_box_text_append (_tmp7_, _tmp10_, _tmp13_);
			}
		}
	}
	_tmp14_ = combo_box;
	gtk_combo_box_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GTK_TYPE_COMBO_BOX, GtkComboBox), 0);
	result = combo_box;
	return result;
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		GPastePanel * self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->targets);
		_g_object_unref0 (_data5_->actions);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static gboolean __lambda7_ (Block5Data* _data5_) {
	GPastePanel * self;
	gboolean result = FALSE;
	GPasteMultiActionCallback _tmp0_;
	void* _tmp0__target;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	self = _data5_->self;
	_tmp0_ = _data5_->confirm_action;
	_tmp0__target = _data5_->confirm_action_target;
	_tmp1_ = gtk_combo_box_get_active_id (G_TYPE_CHECK_INSTANCE_CAST (_data5_->actions, GTK_TYPE_COMBO_BOX, GtkComboBox));
	_tmp2_ = gtk_combo_box_text_get_active_text (_data5_->targets);
	_tmp0_ (_tmp1_, _tmp2_, _tmp0__target);
	result = FALSE;
	return result;
}


static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda7_ (self);
	return result;
}


GtkComboBoxText* g_paste_panel_add_multi_action_setting (GPastePanel* self, gchar** action_labels, int action_labels_length1, int action_labels_length2, gchar** target_labels, int target_labels_length1, const gchar* confirm_label, GPasteMultiActionCallback confirm_action, void* confirm_action_target) {
	GtkComboBoxText* result = NULL;
	Block5Data* _data5_;
	GPasteMultiActionCallback _tmp0_;
	void* _tmp0__target;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	GtkComboBoxText* _tmp2_ = NULL;
	GtkComboBoxText* _tmp3_;
	gint _tmp4_;
	const gchar* _tmp5_;
	GtkButton* _tmp6_ = NULL;
	GtkButton* button;
	GtkComboBoxText* _tmp7_;
	g_return_val_if_fail (G_PASTE_IS_PANEL (self), NULL);
	g_return_val_if_fail (confirm_label != NULL, NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = confirm_action;
	_tmp0__target = confirm_action_target;
	_data5_->confirm_action = _tmp0_;
	_data5_->confirm_action_target = _tmp0__target;
	_tmp1_ = action_labels;
	_tmp1__length1 = action_labels_length1;
	_tmp1__length2 = action_labels_length2;
	_tmp2_ = g_paste_panel_make_combo_box_text (self, _tmp1_, _tmp1__length1, _tmp1__length2);
	_data5_->actions = _tmp2_;
	_tmp3_ = (GtkComboBoxText*) gtk_combo_box_text_new_with_entry ();
	g_object_ref_sink (_tmp3_);
	_data5_->targets = _tmp3_;
	_tmp4_ = self->priv->current_line;
	self->priv->current_line = _tmp4_ + 1;
	gtk_grid_attach (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (_data5_->actions, GTK_TYPE_WIDGET, GtkWidget), 0, _tmp4_, 1, 1);
	gtk_grid_attach_next_to (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_GRID, GtkGrid), G_TYPE_CHECK_INSTANCE_CAST (_data5_->targets, GTK_TYPE_WIDGET, GtkWidget), G_TYPE_CHECK_INSTANCE_CAST (_data5_->actions, GTK_TYPE_WIDGET, GtkWidget), GTK_POS_RIGHT, 1, 1);
	_tmp5_ = confirm_label;
	_tmp6_ = g_paste_panel_add_confirm_button (self, _tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_data5_->targets, GTK_TYPE_WIDGET, GtkWidget));
	button = _tmp6_;
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (button, GTK_TYPE_WIDGET, GtkWidget), "button-press-event", (GCallback) ___lambda7__gtk_widget_button_press_event, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_tmp7_ = _g_object_ref0 (_data5_->targets);
	result = _tmp7_;
	_g_object_unref0 (button);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return result;
}


static void g_paste_panel_class_init (GPastePanelClass * klass) {
	g_paste_panel_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPastePanelPrivate));
	G_OBJECT_CLASS (klass)->finalize = g_paste_panel_finalize;
}


static void g_paste_panel_instance_init (GPastePanel * self) {
	self->priv = G_PASTE_PANEL_GET_PRIVATE (self);
}


static void g_paste_panel_finalize (GObject* obj) {
	GPastePanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, G_PASTE_TYPE_PANEL, GPastePanel);
	G_OBJECT_CLASS (g_paste_panel_parent_class)->finalize (obj);
}


GType g_paste_panel_get_type (void) {
	static volatile gsize g_paste_panel_type_id__volatile = 0;
	if (g_once_init_enter (&g_paste_panel_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPastePanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) g_paste_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPastePanel), 0, (GInstanceInitFunc) g_paste_panel_instance_init, NULL };
		GType g_paste_panel_type_id;
		g_paste_panel_type_id = g_type_register_static (GTK_TYPE_GRID, "GPastePanel", &g_define_type_info, 0);
		g_once_init_leave (&g_paste_panel_type_id__volatile, g_paste_panel_type_id);
	}
	return g_paste_panel_type_id__volatile;
}



